%Dcodage AX25 J.Senlis 
close all;
clear all;
hold off;
[y,fe,bits] = wavread('ax25_05_11.wav'); %Ok 2
%[y,fe,bits] = wavread('sohla8.wav'); %Ok 2

soundsc(y,fe);
y=y';
Ne=length(y);
%y=y+(rand(1,Ne)-0.5);		
DUREE=(Ne-1)/fe;				% DUREE du signal en secondes
Te = 1/fe;						% intervalle de temps entre deux points
t=0:Te:DUREE;					% t contient les temps de 0  DUREE de Te en Te 
%AFFICHER Y(t)
figure(1);						% ouvre une fentre graphique
subplot(4,1,1);				% partage la fentre en 3 lignes 1 colonne et affiche dans la case 1
plot(t,y,'g');					% afficher le signal en fonction du temps 	
hold on;
Tb=1/1200;						%duree 1 bit
Nb=round(Tb*fe);        	% nombre d'ech par bit
COEFF=Nb; 						%pour glisser la fenetre d'analyse de 2  Nb
COEFF1=1;						   %pour calibration  de C0 C1  (automatique maintenant voir plus bas)
maxCC0=0;
minCC0=100;
maxCC1=0;
minCC1=100;
f0=1200;
f1=2200;
t0=1/f0;
t1=1/f1;
w0=2*pi*f0;
w1=2*pi*f1;
cos0=cos(w0*(0:Nb-1)*Te);
sin0=sin(w0*(0:Nb-1)*Te);
cos1=cos(w1*(0:Nb-1)*Te);
sin1=sin(w1*(0:Nb-1)*Te);
NN=floor(Nb/COEFF);			%calcul du dcalage en ech de la fenetre d'analyse
cpte=0;							%compteur d'etats stables
cpto=0;							%compteur pour le calcul des octets de 0  7
cptb1=0;							%nombre de bits  1 entre 2 zeros
maxDC=100;
minDC=-100;
a=1;  							%puissance de 2: 1,2,4....128
W=0;  							%pour calculer l'octet
j=0;								%indice octet
q=1;  							% indice table d'octets
h=1;								%indice table de bits
start=0;							%mis  1 par un fanion
ext=1;							%1 si lsb==0 bit d'extension
fanion=0;						%compteur de fanions
DC0=1;							%pour dtecter un changement +/-1
y1=y;
for  k=1:NN:Ne-Nb         
   A0=abs(sum(y1(k:k+Nb-1).*cos0));
   B0=abs(sum(y1(k:k+Nb-1).*sin0));
   A1=abs(sum(y1(k:k+Nb-1).*cos1));
   B1=abs(sum(y1(k:k+Nb-1).*sin1));
   %C0=(A0^2+B0^2);
   %C1=(A1^2+B1^2);
   if A0>B0   C0=A0+B0/2; else  C0=B0+A0/2; end % approximation plus rapide que sqrt  
   if A1>B1   C1=A1+B1/2; else  C1=B1+A1/2; end   
   if C0>maxCC0 maxCC0=C0; end
   if C0<minCC0 minCC0=C0; end
   if C1>maxCC1 maxCC1=C1; end
   if C1<minCC1 minCC1=C1; end
   if (maxCC1~=minCC1)
   	COEFF1=(maxCC0-minCC0)/(maxCC1-minCC1);  % coeff pour la calibration automatique
   end
   DC=(C0-COEFF1*C1); 								  %coeff amplitude
   j=j+1;
   DCC(j)=DC;CC0(j)=C0;CC1(j)=C1;
   if ((DC)*DC0>0)    									%pas changement  on compte les echantillons cpte
       cpte=cpte+1;
   else 														%changement e ==>0   
      cptb1=round(cpte/COEFF)-1;
      if cptb1<0
         cpte=cpte+1;
      else   
      	if cptb1>6 
   	   	  %erreur='plus de 6...'
              %q; %start=0;ext=1;
      	else	   					%envoi des 1   
         		for m=1:cptb1
                  s(h)=1;h=h+1;cpto=cpto+1;W=W+a;a=2*a;
                  if cpto==1   %test lsb=1 : fin decalage
                     if ext==1 & start==1
                        ext=0;%start==0;%a=2;
                     end
                  end 
         	  	 	if (cpto==8)
                        if start==1 
                                 WW(q)=W;q=q+1;
                        end
                        cpto=0;a=1;W=0;
						end
              	end   
               if cptb1==5 
                    % bit 0 de bourrage  ignorer
               else
              		if cptb1==6 %fanion
                       s(h)=0;h=h+1;WW(q)=W;q=q+1;
                       a=1;W=0;
                       cpto=0;fanion=fanion+1;start=1;ext=1;
                  else
                  	   if cpto==0 & (ext==1) % decalage 1bit si lsb  0 (pas de 1)
                     	   s(h)=0;h=h+1;cpto=cpto+1;
                        	a=1;W=0;%pour decalage      
                     	else                           % pas de decalage
                        	s(h)=0;h=h+1;cpto=cpto+1;
                        	a=2*a;
                     		if (cpto==8)
                              if start==1 
                                 WW(q)=W;q=q+1;
                              end
                              cpto=0;a=1;W=0;
									end
                     	end   
                     
                  end   
                     
        			end   
         end      
     	cpte=0; cptb1=0;
      end     
   DC0=-DC0;   
   end
end
subplot(4,1,4);										
plot(0.51*s,'r.');
subplot(4,1,3)
hold on
plot(t(1:length(DCC)),DCC,'r')
subplot(4,1,2)
hold on
plot(t(1:length(CC0)),CC0,'b')
subplot(4,1,2)
hold on
plot(t(1:length(CC1)),CC1,'r')
fanion
fe
fprintf('%x ',WW)   
fprintf('\r\n\r\n')

fprintf('%c',WW)   
fprintf('\r\n')
